/* -*- mode: c++; c-basic-offset: 3; -*- */
#include "TrendAcc.hh"
#include "lcl_array.hh"
#include "TSeries.hh"

//======================================  Constructor
TrendAcc::TrendAcc(void) {
   reset();
}

//======================================  Destructor
TrendAcc::~TrendAcc() {
}

//======================================  Add data points from a time series
void
TrendAcc::addData(const TSeries& points) {
   size_t N = points.getNSample();
   lcl_array<math_t> data(N);
   size_t nCpy = points.getData(N, data);
   addData(data, nCpy);
}


//======================================  Add double data
void 
TrendAcc::addData(const double* vec, count_t nData) {
   for (count_t i=0; i<nData; i++) addData(math_t(vec[i]));
}

//======================================  Add double data
void 
TrendAcc::addData(const float* vec, count_t nData) {
   for (count_t i=0; i<nData; i++) addData(math_t(vec[i]));
}

//======================================  Add double data
void 
TrendAcc::addData(const int* vec, count_t nData) {
   for (count_t i=0; i<nData; i++) addData(math_t(vec[i]));
}

//======================================  Add double data
void 
TrendAcc::addData(const short* vec, count_t nData) {
   for (count_t i=0; i<nData; i++) addData(math_t(vec[i]));
}

//======================================  Reset accumulator
void 
TrendAcc::reset(void) {
   mNSample  = 0;
   mAvg      = 0.0;
   mSumSq    = 0.0;
   mMinimum  = 0.0;
   mMaximum  = 0.0;
}
